import 'package:fis_lib_report/converts/event_type.dart';
import 'package:fis_lib_report/report/inputImage.dart';
import 'package:fis_lib_report/report_info/block_element_info_interface.dart';
import 'package:fis_lib_report/report_info/element_info.dart';

class InputImageInfo extends ElementInfo implements IBlockElementInfo {
  int? column;

  bool? hasGap;

  bool? isReadOnly;

  bool? isSelected;

  FEventHandler<String>? onSelect = FEventHandler();

  InputImageInfo.fromElement(InputImage inputImage)
      : super.fromElement(inputImage) {
    column = inputImage.column;
    hasGap = inputImage.hasGap;
    isReadOnly = inputImage.isReadOnly;
  }

  @override
  List<ElementInfo>? elementInfos;

  void addImage(String imageUrl) {
    onSelect!.emit(this, imageUrl);
  }

  @override
  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map.addAll(super.toJson());

    map['HasGap'] = hasGap;
    map['IsReadOnly'] = isReadOnly;
    map['IsSelected'] = isSelected;
    return map;
  }
}
