import 'package:fis_lib_report/converts/event_type.dart';
import 'package:fis_lib_report/report/inputText.dart';
import 'package:fis_lib_report/report_info/text_element_info.dart';

class InputTextInfo extends TextElementInfo {
  ///是否只读
  bool? isReadOnly;

  ///当前输入框是否已经监听
  bool? isListening;

  ///UI绑定的文本
  String get text => _text;
  set text(String v) {
    _text = v;
    onTextChange.emit(this, v);
  }

  ///文本改变通知UI变化
  FEventHandler<String> onTextChange = FEventHandler<String>();

  String _text = '';

  InputTextInfo.fromElement(InputText element) : super.fromElement(element) {
    isReadOnly = element.isReadOnly;
    isListening = false;
    text = '';
  }

  @override
  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map.addAll(super.toJson());
    map['IsReadOnly'] = isReadOnly;
    map['Text'] = text;
    return map;
  }
}
