import 'package:fis_lib_report/report/element_type.dart';
import 'package:fis_lib_report/report/interfaces/report_element.dart';
import 'package:fis_lib_report/report/rt_table.dart';
import 'package:fis_lib_report/report_info/block_element_info_interface.dart';
import 'package:fis_lib_report/report_info/element_info.dart';
import 'package:fis_lib_report/report_info/rt_grid.dart';

class RTTableInfo extends RTGridInfo implements IBlockElementInfo {
  bool? autoHide;
  bool? isAverageColumnWidth;
  bool? allowBreakAcrossPages;

  @override
  List<ElementInfo>? elementInfos;

  RTTableInfo.fromElement(RTTable table) : super.fromElement(table) {
    autoHide = table.autoHide;
    isAverageColumnWidth = table.isAverageColumnWidth;
    allowBreakAcrossPages = table.allowBreakAcrossPages;
  }

  @override
  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map.addAll(super.toJson());
    return map;
  }
}
